class ProgressBar():
    def __init__(self, width: int, max_val: int):
        self._width = width
        self._max_val = max_val
        self._value = 0
        print("[" + width * "-" + "]", end="\r")
    
    def __str__(self) -> str:
        progress = int((self._value + 1) / self._max_val * self._width)
        return "[" + progress * "#" + (self._width-progress) * "-" + "]"

    def update(self, value: int) -> None:
        if self._value == self._max_val:
            return

        last_progress = int(self._value / self._max_val * self._width)

        if value >= self._max_val:
            self._value = self._max_val
        else:
            self._value = value
        
        if last_progress < int(self._value / self._max_val * self._width):
            end = "\n" if self._value == self._max_val else "\r"
            print(self, end=end)
    
    def tick(self) -> None:
        if self._value == self._max_val:
            return

        self._value = self._value + 1
        # we made visible progress
        if int(self._value / self._max_val * self._width) > int((self._value - 1) / self._max_val * self._width):
            end = "\n" if self._value == self._max_val else "\r"
            print(self, end=end)
